/*12 / 03 / 2006*/

/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License .
Created by Dev-C++ 5 Beta version 4.9.9.2 
codename:DR-G-1
DR's Number Guess Beta v1.0 for Windows.
*/

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "resource.h"

HWND hwnd;               /* This is the handle for our window */
HWND hCPU_Result ,
     hPlayer_Result ;
HWND hAdd ; 
HWND hButton[2] ;
HHOOK hHook = NULL ;

char Player_Number[18] , Round_Number[12] ;
int Start , Round ;

char CPU[4] , /* CPU's number set. */ 
     Player[4] ; /* Player's number set. */

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK LowLevelKeyboardProc(int,WPARAM ,LPARAM );
BOOL CALLBACK NewGameDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK LGPLDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AboutDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK RulesDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ReadmeDlgProc(HWND, UINT, WPARAM, LPARAM);

/*  Make the class name into a global variable  */
char szClassName[ ] = "DR's Number Guess";

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_ICON));
    wincl.hIconSm = (HICON)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_ICON),IMAGE_ICON, 16, 16, 0);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = MAKEINTRESOURCE(ID_MENU);
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "DR's Number Guess Beta v1.0",       /* Title Text */
           WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX , /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           250,                 /* The programs width */
           350,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );
           
    /* Get "Enter" button signal. */       
    hHook = SetWindowsHookEx( WH_KEYBOARD_LL , LowLevelKeyboardProc , hThisInstance , 0 ) ;

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 HDC hdc;
 PAINTSTRUCT ps ;
 RECT rect ;
 
 static SCROLLINFO si ;
 si.nPos = si.nPos + 20 ;
 
 char Player_Guess[4] ;
 int Pointer = 0 , True = 0 ;
 
    switch (message)                  /* handle the messages */
    {
        case WM_CREATE :
             
             strcpy ( CPU , "" ) ;
             strcpy ( Player , "" ) ;
             
             hButton[0] = CreateWindow ("button","OK",
             WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
             180,10,50,25,
             hwnd,(HMENU)ID_PROCESS,((LPCREATESTRUCT) lParam)->hInstance,NULL);
             
             EnableWindow ( hButton[0] , FALSE ) ;
             
             hButton[1] = CreateWindow ("button","Clear",
             WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
             180,40,50,25,
             hwnd,(HMENU)ID_CLEAR,((LPCREATESTRUCT) lParam)->hInstance,NULL);
             
             EnableWindow ( hButton[1] , FALSE ) ;
             
             hCPU_Result = CreateWindowEx(WS_EX_CLIENTEDGE,"LISTBOX",0, 
             WS_CHILD | WS_VISIBLE | WS_VSCROLL | LBS_MULTIPLESEL , 
             10,90,100,200, hwnd,(HMENU)0, GetModuleHandle(NULL), NULL);
             
             hPlayer_Result = CreateWindowEx(WS_EX_CLIENTEDGE,"LISTBOX",0, 
             WS_CHILD | WS_VISIBLE | WS_VSCROLL | ES_AUTOVSCROLL | LBS_MULTIPLESEL , 
             130,90,100,200, hwnd,(HMENU)0, GetModuleHandle(NULL), NULL);
             
             hAdd = CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT",0, 
             WS_CHILD | WS_VISIBLE , 
             100,40,30,25, hwnd,(HMENU)0, GetModuleHandle(NULL), NULL); 
 
             EnableWindow ( hAdd , FALSE ) ;         
             
        break ;
        
        case WM_PAINT :
             
            hdc = BeginPaint (hwnd,&ps);
            GetClientRect(hwnd,&rect);
            SetBkColor (hdc,GetSysColor (WHITE_BRUSH));
            
            if ( Start != 1 )
              {
                TextOut (hdc,0,0,TEXT("Round :"),7);
                TextOut (hdc,0,20,TEXT("Player's Number :"),17);
              }
            else
              {
                TextOut (hdc, 0 , 0 , TEXT(Round_Number) , strlen(Round_Number) ) ;
                TextOut ( hdc , 0 , 20 , TEXT(Player_Number) , 21 ) ;    
              }
            TextOut (hdc,0,40,TEXT("Add Number :"),12);
            TextOut (hdc,10,70,TEXT("CPU's                    Player's"),33);
            EndPaint (hwnd,&ps);
            
        break ;
        
        case WM_COMMAND :
             switch ( LOWORD ( wParam ) )
               {
                 case ID_EXIT :
                      SendMessage ( hwnd , WM_DESTROY , 0 , 0 ) ;
                 break ;
                 
                 case ID_PROCESS :
                       EnableWindow ( hButton[0] , FALSE ) ;
                       EnableWindow ( hButton[1] , FALSE ) ;
                       EnableWindow ( hAdd , FALSE ) ;
                       
                       /* Start process. */
                       GetWindowText ( hAdd , Player_Guess , 4 ) ;
                       
                       /* Check player's number set. */
                       for ( Pointer = 0 ; Pointer <= 1 ; Pointer ++ )
                         {
                           if ( Player_Guess[Pointer] != Player_Guess[Pointer+1] )
                             {
                               if ( Player_Guess[Pointer] > 48 && Player_Guess[Pointer] < 58 )
                                 {
                                   True ++ ;
                                 }
                             }
                         } 
                         
                       if ( Player_Guess[2] != Player_Guess[0] )
                         {
                           if ( Player_Guess[2] > 48 && Player_Guess[2] < 58 )
                             {
                               True ++ ;
                             }
                         }
                       
                       if ( True == 3 )
                         {
                           if ( process ( Player_Guess ) == 1 )
                             {
                               EnableWindow ( hButton[0] , TRUE ) ;
                               EnableWindow ( hButton[1] , TRUE ) ;
                               EnableWindow ( hAdd , TRUE ) ;
                               SetFocus ( hAdd ) ;
                               
                               if ( Round > 12 )
                                 {
                                 
                                 }
                               
                             }
                         }
                       else
                         {
                           MessageBox( NULL , "Invalid numbers , try again or see the rules please . " , "Oops",
                           MB_ICONINFORMATION | MB_OK);
                           EnableWindow ( hButton[0] , TRUE ) ;
                           EnableWindow ( hButton[1] , TRUE ) ;
                           EnableWindow ( hAdd , TRUE ) ;
                         }
                         
                       SetWindowText ( hAdd , "" ) ;                       
                 break ;
                 
                 case ID_CLEAR :
                      SetWindowText ( hAdd , "" ) ;
                 break ;
                 
                 case ID_NEW_GAME :
                       DialogBox(NULL,TEXT("NewGameBox"),hwnd,NewGameDlgProc);
                 break ;
                 
                 case ID_CPU_NUMBER :
                      
                      if ( strcmp ( CPU , "" ) != 0 )
                        {  
                         MessageBox( NULL , CPU , "You cheat",
                         MB_ICONINFORMATION | MB_OK);         
                        }
                        
                 break ;
                 
                 case ID_LGPL :
                      DialogBox( NULL , TEXT("LGPLBox") , hwnd , LGPLDlgProc ) ;
                 break ;
                 
                 case ID_ABOUT :
                      DialogBox( NULL , TEXT("AboutBox") , hwnd , AboutDlgProc ) ;  
                 break ;

                 case ID_RULES :
                      DialogBox( NULL , TEXT("RuleBox") , hwnd , RulesDlgProc ) ;  
                 break ;

                 case ID_README :
                      DialogBox( NULL , TEXT("ReadmeBox") , hwnd , ReadmeDlgProc ) ;  
                 break ;
                 
               }
        break ;
        case WM_DESTROY:
            remove ( "record.txt" ) ;
            remove ( "record2.txt" ) ;
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}

LRESULT CALLBACK LowLevelKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
 static BOOL fShiftPressed = FALSE ;
 BOOL fHandled = FALSE ;

  if ( nCode == HC_ACTION )
    {
      switch (wParam)
        {
          case WM_KEYUP:
          {
            if ( HIBYTE ( GetKeyState ( 13 ) ) && 
                 GetFocus() == hAdd &&
                 GetActiveWindow() == hwnd )
              {
                SendMessage ( hButton[0] , BM_CLICK , 0 , 0 ) ; 
              }          
              
            if ( HIBYTE ( GetKeyState ( 9 ) ) && 
                 GetActiveWindow() == hwnd )
              {
                SetFocus ( hAdd ) ;
              }       
          }    
          break ;
        }  
     }
     
 return ( fHandled ? TRUE : CallNextHookEx ( hHook , nCode, wParam , lParam ) ) ;
}

